<script setup lang="ts">
import { MESSAGE_ALIGNMENT } from '../BotConversationsView/BotChatMessages.vue'
import GenerationFeedback from '../BotConversationsView/GenerationFeedback.vue'
import ChatBotIcon from '@/assets/chat-bot-icon.svg'
import StudentIcon from '@/assets/user_avatars/student-icon.svg'
import VolunteerIcon from '@/assets/user_avatars/volunteer-icon.svg'
import SystemMessage from '../BotConversationsView/SystemMessage.vue'

const { alignment, message } = defineProps<{
  alignment: MESSAGE_ALIGNMENT
  message: any
}>()

function messageClassFor(
  senderUserType: 'bot' | 'student' | 'volunteer',
  alignment: MESSAGE_ALIGNMENT
) {
  if (senderUserType === 'bot') {
    return 'bot'
  }
  if (alignment === MESSAGE_ALIGNMENT.LEFT) {
    return 'partner'
  }
}
</script>

<template>
  <div class="m-container" :class="alignment">
    <ChatBotIcon
      class="icon"
      v-if="
        alignment === MESSAGE_ALIGNMENT.LEFT && message.senderUserType === 'bot'
      "
    ></ChatBotIcon>
    <VolunteerIcon
      class="icon"
      v-else-if="
        alignment === MESSAGE_ALIGNMENT.LEFT &&
        message.senderUserType === 'volunteer'
      "
    ></VolunteerIcon>
    <StudentIcon
      class="icon"
      v-else-if="
        alignment === MESSAGE_ALIGNMENT.LEFT &&
        message.senderUserType === 'student'
      "
    ></StudentIcon>

    <div
      class="message"
      :class="messageClassFor(message.senderUserType, alignment)"
    >
      <SystemMessage v-if="message.senderUserType === 'system'">
        <span v-html="message.message"></span>
      </SystemMessage>

      <span v-else>{{ message.message }}</span>
      <GenerationFeedback
        v-if="message.traceId"
        :traceId="message.traceId"
        :observationId="message?.observationId ?? ''"
      />
    </div>
  </div>
</template>

<style lang="scss" scoped>
.m-container {
  display: flex;
  width: 100%;
  align-items: end;
  padding-left: 20px;
  padding-right: 20px;
}
.icon {
  flex-shrink: 0;
  width: 30px;
  height: 30px;
}

.message {
  max-width: 80%;
  line-height: 140%;
  overflow-wrap: break-word;
  font-size: 16px;
  font-family: $font-family-default;
  white-space: pre-line;
  text-align: left;
  border-radius: 20px;
}

.center {
  justify-content: center;
}

.right {
  justify-content: end;
  & .message {
    padding: 10px 16px;
    background-color: $c-background-blue;
  }
}
.left {
  justify-content: start;

  & .bot {
    background-color: $selected-green;
    padding: 10px 16px;
  }

  & .partner {
    padding: 10px 16px;
    background-color: $c-background-grey;
  }
}
</style>
